fstests: remove DMAPI support from build system
[xfstests-dev.git] / common / rc
index 6487b9f2d010cfb4208893181e6a22cc53cbf45c..aea0d076d111e4b12b0b74bbd77c6c924e5c554a 100644 (file)
--- a/common/rc
+++ b/common/rc
@@ -6,16 +6,6 @@
 
 BC=$(which bc 2> /dev/null) || BC=
 
-# Some tests are not relevant or functional when testing XFS realtime
-# subvolumes along with the rtinherit=1 mkfs option.  In these cases,
-# this test will opt-out of the test.
-_require_no_rtinherit()
-{
-       [ "$FSTYP" = "xfs" ] && echo "$MKFS_OPTIONS" |
-               egrep -q "rtinherit([^=]|=1|$)" && \
-               _notrun "rtinherit mkfs option is not supported by this test."
-}
-
 _require_math()
 {
        if [ -z "$BC" ]; then
@@ -31,19 +21,13 @@ _math()
 
 dd()
 {
-   if [ "$HOSTOS" == "Linux" ]
-   then        
        command dd --help 2>&1 | grep noxfer >/dev/null
-       
        if [ "$?" -eq 0 ]
            then
                command dd status=noxfer $@
            else
                command dd $@
-       fi
-   else
-       command dd $@
-   fi
+       fi
 }
 
 # Prints the md5 checksum of a given file
@@ -144,6 +128,7 @@ case "$FSTYP" in
     9p)
         ;;
     ceph)
+        . ./common/ceph
         ;;
     glusterfs)
         ;;
@@ -292,12 +277,11 @@ _mount_ops_filter()
     local params="$*"
     local last_index=$(( $# - 1 ))
 
-    #get mount point to handle dmapi mtpt option correctly
     [ $last_index -gt 0 ] && shift $last_index
     local fs_escaped=$1
 
-    echo $params | sed -e 's/dmapi/dmi/' \
-        $PERL_PROG -ne "s#mtpt=[^,|^\n|^\s]*#mtpt=$fs_escaped\1\2#; print;"
+    echo $params | \
+        $PERL_PROG -ne "s#mtpt=[^,|^\n|^\s]*#mtpt=$fs_escaped\1\2#; print;"
 
 }
 
@@ -514,7 +498,7 @@ _scratch_metadump()
        [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
                options="-l $SCRATCH_LOGDEV"
 
-       xfs_metadump $options "$@" $SCRATCH_DEV $dumpfile
+       $XFS_METADUMP_PROG $options "$@" $SCRATCH_DEV $dumpfile
 }
 
 _setup_large_ext4_fs()
@@ -941,110 +925,115 @@ _available_memory_bytes()
 # _scratch_mkfs_sized <size in bytes> [optional blocksize]
 _scratch_mkfs_sized()
 {
-    local fssize=$1
-    local blocksize=$2
-    local def_blksz
-
-    case $FSTYP in
-    xfs)
-       def_blksz=`echo $MKFS_OPTIONS|sed -rn 's/.*-b ?size= ?+([0-9]+).*/\1/p'`
-       ;;
-    ext2|ext3|ext4|ext4dev|udf|btrfs|reiser4|ocfs2|reiserfs)
-       def_blksz=`echo $MKFS_OPTIONS| sed -rn 's/.*-b ?+([0-9]+).*/\1/p'`
-       ;;
-    jfs)
-       def_blksz=4096
-       ;;
-    esac
-
-    [ -n "$def_blksz" ] && blocksize=$def_blksz
-    [ -z "$blocksize" ] && blocksize=4096
+       local fssize=$1
+       local blocksize=$2
+       local def_blksz
 
+       case $FSTYP in
+       xfs)
+               def_blksz=`echo $MKFS_OPTIONS | sed -rn 's/.*-b ?size= ?+([0-9]+).*/\1/p'`
+               ;;
+       ext2|ext3|ext4|ext4dev|udf|btrfs|reiser4|ocfs2|reiserfs)
+               def_blksz=`echo $MKFS_OPTIONS | sed -rn 's/.*-b ?+([0-9]+).*/\1/p'`
+               ;;
+       jfs)
+               def_blksz=4096
+               ;;
+       esac
 
-    local re='^[0-9]+$'
-    if ! [[ $fssize =~ $re ]] ; then
-        _notrun "error: _scratch_mkfs_sized: fs size \"$fssize\" not an integer."
-    fi
-    if ! [[ $blocksize =~ $re ]] ; then
-        _notrun "error: _scratch_mkfs_sized: block size \"$blocksize\" not an integer."
-    fi
+       [ -n "$def_blksz" ] && blocksize=$def_blksz
+       [ -z "$blocksize" ] && blocksize=4096
 
-    local blocks=`expr $fssize / $blocksize`
+       local re='^[0-9]+$'
+       if ! [[ $fssize =~ $re ]] ; then
+               _notrun "error: _scratch_mkfs_sized: fs size \"$fssize\" not an integer."
+       fi
+       if ! [[ $blocksize =~ $re ]] ; then
+               _notrun "error: _scratch_mkfs_sized: block size \"$blocksize\" not an integer."
+       fi
 
-    if [ "$HOSTOS" == "Linux" -a -b "$SCRATCH_DEV" ]; then
-       local devsize=`blockdev --getsize64 $SCRATCH_DEV`
-       [ "$fssize" -gt "$devsize" ] && _notrun "Scratch device too small"
-    fi
+       local blocks=`expr $fssize / $blocksize`
 
-    case $FSTYP in
-    xfs)
-       # don't override MKFS_OPTIONS that set a block size.
-       echo $MKFS_OPTIONS |egrep -q "b?size="
-       if [ $? -eq 0 ]; then
-               _scratch_mkfs_xfs -d size=$fssize
-       else
-               _scratch_mkfs_xfs -d size=$fssize -b size=$blocksize
-       fi
-       ;;
-    ext2|ext3|ext4|ext4dev)
-       ${MKFS_PROG}.$FSTYP -F $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV $blocks
-       ;;
-    gfs2)
-       # mkfs.gfs2 doesn't automatically shrink journal files on small
-       # filesystems, so the journal files may end up being bigger than the
-       # filesystem, which will cause mkfs.gfs2 to fail.  Until that's fixed,
-       # shrink the journal size to at most one eigth of the filesystem and at
-       # least 8 MiB, the minimum size allowed.
-       local min_journal_size=8
-       local default_journal_size=128
-       if (( fssize/8 / (1024*1024) < default_journal_size )); then
-           local journal_size=$(( fssize/8 / (1024*1024) ))
-           (( journal_size >= min_journal_size )) || journal_size=$min_journal_size
-           MKFS_OPTIONS="-J $journal_size $MKFS_OPTIONS"
+       if [ -b "$SCRATCH_DEV" ]; then
+               local devsize=`blockdev --getsize64 $SCRATCH_DEV`
+               [ "$fssize" -gt "$devsize" ] && _notrun "Scratch device too small"
        fi
-       ${MKFS_PROG}.$FSTYP $MKFS_OPTIONS -O -b $blocksize $SCRATCH_DEV $blocks
-       ;;
-    ocfs2)
-       yes | ${MKFS_PROG}.$FSTYP -F $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV $blocks
-       ;;
-    udf)
-       $MKFS_UDF_PROG $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV $blocks
-       ;;
-    btrfs)
-       local mixed_opt=
-       # minimum size that's needed without the mixed option.
-       # Ref: btrfs-prog: btrfs_min_dev_size()
-       # Non mixed mode is also the default option.
-       (( fssize < $((256 * 1024 *1024)) )) && mixed_opt='--mixed'
-       $MKFS_BTRFS_PROG $MKFS_OPTIONS $mixed_opt -b $fssize $SCRATCH_DEV
-       ;;
-    jfs)
-       ${MKFS_PROG}.$FSTYP $MKFS_OPTIONS $SCRATCH_DEV $blocks
-       ;;
-    reiserfs)
-       ${MKFS_PROG}.$FSTYP $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV $blocks
-       ;;
-    reiser4)
-       # mkfs.resier4 requires size in KB as input for creating filesystem
-       $MKFS_REISER4_PROG $MKFS_OPTIONS -y -b $blocksize $SCRATCH_DEV \
-                          `expr $fssize / 1024`
-       ;;
-    f2fs)
-       # mkfs.f2fs requires # of sectors as an input for the size
-       local sector_size=`blockdev --getss $SCRATCH_DEV`
-       $MKFS_F2FS_PROG $MKFS_OPTIONS $SCRATCH_DEV `expr $fssize / $sector_size`
-       ;;
-    tmpfs)
-       local free_mem=`_free_memory_bytes`
-       if [ "$free_mem" -lt "$fssize" ] ; then
-          _notrun "Not enough memory ($free_mem) for tmpfs with $fssize bytes"
+
+       if [ "$FSTYP" = "xfs" ] && [ -b "$SCRATCH_RTDEV" ]; then
+               local rtdevsize=`blockdev --getsize64 $SCRATCH_RTDEV`
+               [ "$fssize" -gt "$rtdevsize" ] && _notrun "Scratch rt device too small"
+               rt_ops="-r size=$fssize"
        fi
-       export MOUNT_OPTIONS="-o size=$fssize $TMPFS_MOUNT_OPTIONS"
-       ;;
-    *)
-       _notrun "Filesystem $FSTYP not supported in _scratch_mkfs_sized"
-       ;;
-    esac
+
+       case $FSTYP in
+       xfs)
+               # don't override MKFS_OPTIONS that set a block size.
+               echo $MKFS_OPTIONS |egrep -q "b?size="
+               if [ $? -eq 0 ]; then
+                       _scratch_mkfs_xfs -d size=$fssize $rt_ops
+               else
+                       _scratch_mkfs_xfs -d size=$fssize $rt_ops -b size=$blocksize
+               fi
+               ;;
+       ext2|ext3|ext4|ext4dev)
+               ${MKFS_PROG} -t $FSTYP -F $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV $blocks
+               ;;
+       gfs2)
+               # mkfs.gfs2 doesn't automatically shrink journal files on small
+               # filesystems, so the journal files may end up being bigger than the
+               # filesystem, which will cause mkfs.gfs2 to fail.  Until that's fixed,
+               # shrink the journal size to at most one eigth of the filesystem and at
+               # least 8 MiB, the minimum size allowed.
+               local min_journal_size=8
+               local default_journal_size=128
+               if (( fssize/8 / (1024*1024) < default_journal_size )); then
+                       local journal_size=$(( fssize/8 / (1024*1024) ))
+                       (( journal_size >= min_journal_size )) || journal_size=$min_journal_size
+                       MKFS_OPTIONS="-J $journal_size $MKFS_OPTIONS"
+               fi
+               ${MKFS_PROG} -t $FSTYP $MKFS_OPTIONS -O -b $blocksize $SCRATCH_DEV $blocks
+               ;;
+       ocfs2)
+               yes | ${MKFS_PROG} -t $FSTYP -F $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV $blocks
+               ;;
+       udf)
+               $MKFS_UDF_PROG $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV $blocks
+               ;;
+       btrfs)
+               local mixed_opt=
+               # minimum size that's needed without the mixed option.
+               # Ref: btrfs-prog: btrfs_min_dev_size()
+               # Non mixed mode is also the default option.
+               (( fssize < $((256 * 1024 *1024)) )) && mixed_opt='--mixed'
+               $MKFS_BTRFS_PROG $MKFS_OPTIONS $mixed_opt -b $fssize $SCRATCH_DEV
+               ;;
+       jfs)
+               ${MKFS_PROG} -t $FSTYP $MKFS_OPTIONS $SCRATCH_DEV $blocks
+               ;;
+       reiserfs)
+               ${MKFS_PROG} -t $FSTYP $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV $blocks
+               ;;
+       reiser4)
+               # mkfs.resier4 requires size in KB as input for creating filesystem
+               $MKFS_REISER4_PROG $MKFS_OPTIONS -y -b $blocksize $SCRATCH_DEV \
+                                  `expr $fssize / 1024`
+               ;;
+       f2fs)
+               # mkfs.f2fs requires # of sectors as an input for the size
+               local sector_size=`blockdev --getss $SCRATCH_DEV`
+               $MKFS_F2FS_PROG $MKFS_OPTIONS $SCRATCH_DEV `expr $fssize / $sector_size`
+               ;;
+       tmpfs)
+               local free_mem=`_free_memory_bytes`
+               if [ "$free_mem" -lt "$fssize" ] ; then
+                  _notrun "Not enough memory ($free_mem) for tmpfs with $fssize bytes"
+               fi
+               export MOUNT_OPTIONS="-o size=$fssize $TMPFS_MOUNT_OPTIONS"
+               ;;
+       *)
+               _notrun "Filesystem $FSTYP not supported in _scratch_mkfs_sized"
+               ;;
+       esac
 }
 
 # Emulate an N-data-disk stripe w/ various stripe units
@@ -1062,7 +1051,7 @@ _scratch_mkfs_geom()
     case $FSTYP in
     xfs)
        if echo "$MKFS_OPTIONS" | egrep -q "b?size="; then
-               MKFS_OPTIONS=$(echo "$MKFS_OPTIONS" | sed -r "s/(b?size=)[0-9]+/\1$blocksize/")
+               MKFS_OPTIONS=$(echo "$MKFS_OPTIONS" | sed -r "s/(b?size=)[0-9]+k?/\1$blocksize/")
        else
                MKFS_OPTIONS+=" -b size=$blocksize"
        fi
@@ -1101,13 +1090,13 @@ _scratch_mkfs_blocksized()
        _scratch_mkfs_xfs $MKFS_OPTIONS -b size=$blocksize
        ;;
     ext2|ext3|ext4)
-       ${MKFS_PROG}.$FSTYP -F $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV
+       ${MKFS_PROG} -t $FSTYP -F $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV
        ;;
     gfs2)
-       ${MKFS_PROG}.$FSTYP $MKFS_OPTIONS -O -b $blocksize $SCRATCH_DEV
+       ${MKFS_PROG} -t $FSTYP $MKFS_OPTIONS -O -b $blocksize $SCRATCH_DEV
        ;;
     ocfs2)
-       yes | ${MKFS_PROG}.$FSTYP -F $MKFS_OPTIONS -b $blocksize -C $blocksize $SCRATCH_DEV
+       yes | ${MKFS_PROG} -t $FSTYP -F $MKFS_OPTIONS -b $blocksize -C $blocksize $SCRATCH_DEV
        ;;
     *)
        _notrun "Filesystem $FSTYP not supported in _scratch_mkfs_blocksized"
@@ -1450,24 +1439,6 @@ _supported_fs()
     _notrun "not suitable for this filesystem type: $FSTYP"
 }
 
-
-# tests whether $FSTYP is one of the supported OSes for a test
-#
-_supported_os()
-{
-    local h
-
-    for h
-    do
-       if [ "$h" = "$HOSTOS" ]
-       then
-           return
-       fi
-    done
-
-    _notrun "not suitable for this OS: $HOSTOS"
-}
-
 # check if a FS on a device is mounted
 # if so, verify that it is mounted on mount point
 # if fstype is given as argument, verify that it is also
@@ -1626,6 +1597,37 @@ _require_scratch_size()
        [ $devsize -lt $1 ] && _notrun "scratch dev too small"
 }
 
+# require a scratch dev of a minimum size (in kb) and should not be checked
+# post test
+_require_scratch_size_nocheck()
+{
+       [ $# -eq 1 ] || _fail "_require_scratch_size: expected size param"
+
+       _require_scratch_nocheck
+       local devsize=`_get_device_size $SCRATCH_DEV`
+       [ $devsize -lt $1 ] && _notrun "scratch dev too small"
+}
+
+# require scratch fs which supports >16T of filesystem size.
+_require_scratch_16T_support()
+{
+       case $FSTYP in
+       ext2|ext3|f2fs)
+               _notrun "$FSTYP doesn't support >16T filesystem"
+               ;;
+       ext4)
+               _scratch_mkfs >> $seqres.full 2>&1
+               _scratch_mount
+               local blocksize=$(_get_block_size $SCRATCH_MNT)
+               if [ $blocksize -lt 4096 ]; then
+                       _notrun "This test requires >16T fs support"
+               fi
+               _scratch_unmount
+               ;;
+       *)
+               ;;
+       esac
+}
 
 # this test needs a test partition - check we're ok & mount it
 #
@@ -1755,11 +1757,6 @@ _require_logdev()
 #
 _require_loop()
 {
-    if [ "$HOSTOS" != "Linux" ]
-    then
-       _notrun "This test requires linux for loopback device support"
-    fi
-
     modprobe loop >/dev/null 2>&1
     if grep loop /proc/devices >/dev/null 2>&1
     then
@@ -1773,11 +1770,6 @@ _require_loop()
 #
 _require_ext2()
 {
-    if [ "$HOSTOS" != "Linux" ]
-    then
-       _notrun "This test requires linux for ext2 filesystem support"
-    fi
-
     modprobe ext2 >/dev/null 2>&1
     if grep ext2 /proc/filesystems >/dev/null 2>&1
     then
@@ -1896,7 +1888,8 @@ _require_dm_target()
        _require_sane_bdev_flush $SCRATCH_DEV
        _require_command "$DMSETUP_PROG" dmsetup
 
-       _normalize_mount_options | egrep -q "dax(=always| |$)"
+       _normalize_mount_options | egrep -q "dax(=always| |$)" || \
+                       test -e "/sys/block/$(_short_dev $SCRATCH_DEV)/dax"
        if [ $? -eq 0 ]; then
                case $target in
                stripe|linear|log-writes)
@@ -1984,6 +1977,22 @@ _require_aiodio()
     _require_odirect
 }
 
+# this test requires that the kernel supports IO_URING
+_require_io_uring()
+{
+       $here/src/feature -R
+       case $? in
+       0)
+               ;;
+       1)
+               _notrun "kernel does not support IO_URING"
+               ;;
+       *)
+               _fail "unexpected error testing for IO_URING support"
+               ;;
+       esac
+}
+
 # this test requires that a test program exists under src/
 # $1 - command (require)
 #
@@ -2158,10 +2167,17 @@ _require_xfs_io_command()
        local param="$*"
        local param_checked=""
        local opts=""
+       local attr_info=""
 
        local testfile=$TEST_DIR/$$.xfs_io
        local testio
        case $command in
+       "lsattr")
+               # Test xfs_io lsattr support and filesystem FS_IOC_FSSETXATTR
+               # support.
+               testio=`$XFS_IO_PROG -F -f -c "lsattr $param" $testfile 2>&1`
+               param_checked="$param"
+               ;;
        "chattr")
                local testdir=$TEST_DIR/$$.attr_dir
                mkdir $TEST_DIR/$$.attr_dir
@@ -2173,9 +2189,11 @@ _require_xfs_io_command()
                # 'tPnE' flags are only valid for a directory so check them on a directory.
                if echo "$param" | egrep -q 't|P|n|E'; then
                        testio=`$XFS_IO_PROG -F -c "chattr +$param" $testdir 2>&1`
+                       attr_info=`$XFS_IO_PROG -F -r -c "lsattr" $testdir | awk '{print $1}'`
                        $XFS_IO_PROG -F -r -c "chattr -$param" $testdir 2>&1
                else
                        testio=`$XFS_IO_PROG -F -f -c "chattr +$param" $testfile 2>&1`
+                       attr_info=`$XFS_IO_PROG -F -r -c "lsattr" $testfile | awk '{print $1}'`
                        $XFS_IO_PROG -F -r -c "chattr -$param" $testfile 2>&1
                fi
                param_checked="+$param"
@@ -2300,6 +2318,19 @@ _require_xfs_io_command()
                echo $testio | grep -q "\(invalid option\|not supported\)" && \
                        _notrun "xfs_io $command doesn't support $param"
        fi
+
+       # On XFS, ioctl(FSSETXATTR)(called by xfs_io -c "chattr") maskes off unsupported
+       # or invalid flags silently so need to check these flags by extra ioctl(FSGETXATTR)
+       # (called by xfs_io -c "lsattr").
+       # The following URL explains why we don't change the behavior of XFS.
+       # https://www.spinics.net/lists/linux-xfs/msg44725.html
+       if [ -n "$attr_info" -a "$FSTYP" = "xfs" ]; then
+               local num=${#param}
+               for i in $(seq 0 $((num-1))); do
+                       echo $attr_info | grep -q "${param:$i:1}" || \
+                               _notrun "xfs_io $command +${param:$i:1} support is missing (unknown flag in kernel)"
+               done
+       fi
 }
 
 # check that kernel and filesystem support direct I/O
@@ -2360,10 +2391,22 @@ _require_scratch_swapfile()
        # Minimum size for mkswap is 10 pages
        _format_swapfile "$SCRATCH_MNT/swap" $(($(get_page_size) * 10))
 
-       if ! swapon "$SCRATCH_MNT/swap" >/dev/null 2>&1; then
-               _scratch_unmount
-               _notrun "swapfiles are not supported"
-       fi
+       # ext* and xfs have supported all variants of swap files since their
+       # introduction, so swapon should not fail.
+       case "$FSTYP" in
+       ext2|ext3|ext4|xfs)
+               if ! swapon "$SCRATCH_MNT/swap" >/dev/null 2>&1; then
+                       _scratch_unmount
+                       _fail "swapon failed for $FSTYP"
+               fi
+               ;;
+       *)
+               if ! swapon "$SCRATCH_MNT/swap" >/dev/null 2>&1; then
+                       _scratch_unmount
+                       _notrun "swapfiles are not supported"
+               fi
+               ;;
+       esac
 
        swapoff "$SCRATCH_MNT/swap" >/dev/null 2>&1
        _scratch_unmount
@@ -3211,10 +3254,27 @@ _check_s_dax()
        local exp_s_dax=$2
 
        local attributes=$($XFS_IO_PROG -c 'statx -r' $target | awk '/stat.attributes / { print $3 }')
+
+       # The original attribute bit value, STATX_ATTR_DAX (0x2000), conflicted
+       # with STATX_ATTR_MOUNT_ROOT.  Therefore, STATX_ATTR_DAX was changed to
+       # 0x00200000.
+       #
+       # Because DAX tests do not run on root mounts, STATX_ATTR_MOUNT_ROOT
+       # should always be 0.  Check for the old flag and fail the test if that
+       # occurs.
+
+       if [ $(( attributes & 0x2000 )) -ne 0 ]; then
+               echo "$target has an unexpected STATX_ATTR_MOUNT_ROOT flag set"
+               echo "which used to be STATX_ATTR_DAX"
+               echo "     This test should not be running on the root inode..."
+               echo "     Does the kernel have the following patch?"
+               echo "     72d1249e2ffd uapi: fix statx attribute value overlap for DAX & MOUNT_ROOT"
+       fi
+
        if [ $exp_s_dax -eq 0 ]; then
-               (( attributes & 0x2000 )) && echo "$target has unexpected S_DAX flag"
+               (( attributes & 0x00200000 )) && echo "$target has unexpected S_DAX flag"
        else
-               (( attributes & 0x2000 )) || echo "$target doen't have expected S_DAX flag"
+               (( attributes & 0x00200000 )) || echo "$target doesn't have expected S_DAX flag"
        fi
 }
 
@@ -3226,7 +3286,7 @@ _check_xflag()
        if [ $exp_xflag -eq 0 ]; then
                _test_inode_flag dax $target && echo "$target has unexpected FS_XFLAG_DAX flag"
        else
-               _test_inode_flag dax $target || echo "$target doen't have expected FS_XFLAG_DAX flag"
+               _test_inode_flag dax $target || echo "$target doesn't have expected FS_XFLAG_DAX flag"
        fi
 }
 
@@ -3981,11 +4041,18 @@ _get_file_block_size()
                echo "Missing mount point argument for _get_file_block_size"
                exit 1
        fi
-       if [ "$FSTYP" = "ocfs2" ]; then
+
+       case "$FSTYP" in
+       "ocfs2")
                stat -c '%o' $1
-       else
+               ;;
+       "xfs")
+               _xfs_get_file_block_size $1
+               ;;
+       *)
                _get_block_size $1
-       fi
+               ;;
+       esac
 }
 
 # Get the minimum block size of an fs.
@@ -4322,6 +4389,12 @@ _require_mknod()
        rm -f $TEST_DIR/$seq.null
 }
 
+_getcap()
+{
+       $GETCAP_PROG "$@" | _filter_getcap
+       return ${PIPESTATUS[0]}
+}
+
 init_rc
 
 ################################################################################